# COMPSHIFT - Set emission line centers, one per fiber, then compute mean
#             shift of Hectospec or Hectochelle images relative to standard
# December 15, 2003
# By Doug Mink, SAO Telescope Data Center

procedure compshift (refimage, images, centers)

file	refimage=""	{prompt="Image file in which to find line centers"}
file	images=""	{prompt="Image files for which to find line centers"}
file	centers=""	{prompt="File containing nominal coordinates of lines"}
file	refcenters=""	{prompt="File containing reference line centers"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}

begin

file	refim, temp1, temp2, imagecenters, listfile, filename
string	chip1, chip2, arg, line, imagelist
bool	dellist, vb
char	tchar

	refim = refimage
	imagelist = images
	vb = verbose
	refc = refcenters

	digiphot
	apphot
	wcstools

# Find emission line centers for the reference image from nominal positions
	temp1 = mktemp ("bluecent")
	center.coords = "bluecenters0"
	center.output = temp1
	center.plotfile = ""
	center.datapars = ""
	center.centerpars = ""
	center.interactive = no
	center.radplots = no
	center.icommands = ""
	center.gcommands = ""
	center.flpar = no
	center.mode = "ql"

# Find emission line centers for the reference image from nominal positions
	if (refc == "") {
	    center (refim)

# Extract center coordinates for each fiber from center output file
	    refcenters = refim // ".blue"
	    refc = refcenters
	    list = temp1
            i = 0
	    arg = "-s 44 " // temp1 // " 7 8"
	    getcol (arg, >refc)
	    }
	center.coords = refc

#  Make list file of image files from input
        tchar = substr (imagelist,1,1)
        if (tchar != '@') {
            temp2 = mktemp ("cmpshft")
            print (imagelist,>temp2)
            listfile = temp2
            }
        else
            listfile = substr(imagelist,2,256)

# Fit centers for each image, one at a time
	list = listfile
	while (fscan (list,filename) != EOF) {
	    if (vb) {
		print ("Finding centers in ",filename)
		}
	    center (filename)

# Extract center coordinates for each fiber from center output file
	    list = temp1
            i = 0
	    arg = "-mps 44 " // temp1 // " 7-2"
	    getcol (arg) | scan (dx)
	    arg = "-mps 44 " // temp1 // " 8-3"
	    getcol (arg) | scan (dy)
	    if (vb) {
		print (filename,": dx=",dx," dy=",dy)
		}
#	    arg = filename // " shiftx=" // dx // " shifty=" // dy
	    sethead (arg)
	    }

#	imdelete (temp1)
#	imdelete (temp2)
end

# Dec 15 2003	New program to comput X-Y shifts from a reference file
